-- $ ghci counter_adhoc.hs
-- > import C
-- > run myprog

module C where

type WithCounter a = Int -> (a,Int)

incr :: WithCounter ()
incr i = ((),i+1)

get :: WithCounter Int
get i = (i,i)

set :: Int -> WithCounter ()
set v _ = ((),v)

ret :: a -> WithCounter a
ret a i = (a,i)

bind :: WithCounter a -> (a -> WithCounter b) -> WithCounter b
bind f g i = let (v,j) = f i in g v j

run :: WithCounter a -> a
run f = let (a,_) = f 0 in a

-- Test

myprog :: WithCounter Int
myprog = bind (set 2) (\_ -> bind incr (\_ -> get))
